/* chat_client.c: client che chiama la procedura remota */

#include <stdio.h>
#include <rpc/rpc.h>
#include "chat.h"
#define DIM_NAME 30
#define DIM_MSG 100
#define DIM_HOST_NAME 1024

main(int argc, char *argv[])
{

  CLIENT *cl;
  char *server_host, client_host[1024];
  Dati dati;
  Messaggio msg;
  int len;
  char name[20];
  int *reg_res, *unreg_res;
  void *say_res;



  if (argc != 2)
  {
    fprintf(stderr, "uso: %s nome_host\n", argv[0]);
    exit(1);
  }

  printf("Chat client: inizio...\n");

  server_host = argv[1];

  //client_host=(char*)malloc(DIM_HOST_NAME);

  // usando un ptr a char come tipo di client_host la gethostname fallisce... perch?

  if (gethostname(client_host, sizeof(client_host))<0)
  {
    fprintf(stderr, "error: gethostname\n");
    exit(1);
  }

  strcpy(dati.client_host, client_host);

  /* Creazione gestore di protocollo */

  cl = clnt_create(server_host, CHATPROG, CHATVERS, "udp");
  if (cl == NULL)
  {
    clnt_pcreateerror(server_host);
    exit(1);
  }
  printf("Creato gestore di protocollo\n");

  /* Registrazione utente */

  printf("Registrazione\n");
  printf("Nome (max 20 caratteri)? ");
  gets(name);
  printf("name = %s\n", name);
  strcpy(dati.client_name, name);

  printf("Invoco register con i dati:\n");
  printf("dati.client_name = %s\n", dati.client_name);
  printf("dati.client_host = %s\n", dati.client_host);


  reg_res=register_1(&dati, cl);

  if (reg_res == NULL)
  {
    fprintf(stderr, "%s: %s fallisce la register\n", argv[0], server_host);
    clnt_perror(cl, server_host);
    exit(1);
  }

  if (*reg_res==0) printf("Registrazione effettuata\n");
  else
  {
    printf("Registrazione non effettuata\n");
    printf("\nChat client: termino...\n");
    exit(1);
  }

  strcpy(msg.mitt, name);


  /* ciclo di interazione con l'utente ------- */

  printf("Inserire messaggi, EOF per terminare:\n");
  printf("> ");

  while (gets(msg.body))
  {

    say_res = say_something_1(&msg, cl);

    if (say_res == NULL)
    {
      fprintf(stderr, "%s: %s fallisce la say_something\n", argv[0], server_host);
      clnt_perror(cl, server_host);
      exit(1);
    }

    printf("> ");

    //printf("Inserire messaggi, EOF per terminare: ");
  }

  unreg_res=unregister_1(&dati, cl);
  if (unreg_res == NULL)
  {
    fprintf(stderr, "%s: %s fallisce la unregister\n", argv[0], server_host);
    clnt_perror(cl, server_host);
    exit(1);
  }

  if (*unreg_res==0) printf("Cancellazione effettuata\n");
  else 	printf("Cancellazione non effettuata\n");

  printf("\nChat client: termino...\n");
  exit(0);
}
