/* chat_proc.c: implementazione delle procedure remote del server */

#include <stdio.h>
#include <rpc/rpc.h>
#include "chat.h"
#include "callback.h"
#define USER_HOST_MAX 10


static char user_host[USER_HOST_MAX][100];
static int user_count[USER_HOST_MAX];
int user_num=0;
/* Gestori di trasporto per la comunicazioni con tutti
 * gli host sottoscrittori. Pi client che si
 * sottoscrivono da uno stesso host condividono il
 * processo di callback --> si ha al pi un gestore di
 * trasporto per ogni macchina
 */
static CLIENT * clienti[USER_HOST_MAX];


void doCallback(char *msg)
{
  CLIENT * cl;

  int i;

  printf("Eseguo doCallback...\n");
  for (i=0; i<USER_HOST_MAX; i++)
  {
    printf("i = %d,  user_host[i] = %s, user_count[i] = %d\n", i, user_host[i], user_count[i]);
    if (strcmp(user_host[i], "")!=0)
    {
      cl = clienti[i];
      if (cl == NULL)
      {
        printf("Errore durante il reperimento del gestore di trasporto\n");
        exit(1);
      }
      callback_1(&msg, cl);
    }
  }
}


int *register_1_svc(Dati *dati, struct svc_req *rp)
{

  static int ris;
  char callback_msg[30];
  int i, pres;

  printf("Eseguo register...\n");
  printf("Dati ricevuti:\n");
  printf("dati->client_name = %s\n", dati->client_name);
  printf("dati->client_host = %s\n", dati->client_host);

  ris=-1; pres=0;

  /* verifico se sullo stesso host c' gi un utente registrato, se si incremento il contatore corrispondente... */
  /* NOTA: per semplificare la realizzazione NON si controlla l'unicita' del nome del sottoscrittore */
  for (i=0;i<USER_HOST_MAX; i++)
  {
    if (strcmp(user_host[i], dati->client_host)==0)
    {
      user_count[i]++;
      pres=1;
      ris=0;
      break;
    }
  }

  /* ... altrimenti inserisco una nuova entry */

  if (pres!=1)
  {
    for (i=0;i<USER_HOST_MAX; i++)
    {
      if (strcmp(user_host[i], "")==0)
      {
        strcpy(user_host[i], dati->client_host);
        user_count[i]=1;
        clienti[i]=clnt_create(user_host[i], CALLBACKPROG, CALLBACKVERS, "udp");
        if (clienti[i] == NULL)
        {
          clnt_pcreateerror(user_host[i]);
          exit(1);
        }
        ris=0;
        break;
      }
    }
  }

  if (ris==0)
  {
    strcpy(callback_msg, "Ingresso di ");
    strcat(callback_msg, dati->client_name);
    user_num++;
    printf("Numero di utenti registrati: %d\n", user_num);
    doCallback(callback_msg);
  }
  return (&ris);
}


void *say_something_1_svc(Messaggio *msg, struct svc_req *rp)
{

  char callback_msg[30];

  printf("Eseguo say_something...\n");
  printf("Dati ricevuti:\n");
  printf("mitt = %s\n", msg->mitt);
  printf("body = %s\n", msg->body);
  strcpy(callback_msg, msg->mitt);
  strcat(callback_msg, ": ");
  strcat(callback_msg, msg->body);
  //printf("callback_msg = %s\n", callback_msg);
  doCallback(callback_msg);
}




int *unregister_1_svc(Dati *dati, struct svc_req *rp)
{
  static int ris;
  char callback_msg[30];
  int i;

  printf("Eseguo unregister...\n");
  printf("Dati ricevuti:\n");
  printf("dati->client_name = %s\n", dati->client_name);
  printf("dati->client_host = %s\n", dati->client_host);

  ris=-1;

  for (i=0;i<USER_HOST_MAX; i++)
  {
    if ((strcmp(user_host[i], dati->client_host)==0)){
      user_count[i]--;
      user_num--;
      if(user_count[i]==0) strcpy(user_host[i], "");
      strcpy(callback_msg, "Uscita di ");
      strcat(callback_msg, dati->client_name);
      printf("callback_msg = %s\n", callback_msg);
      printf("Numero di utenti registrati: %d\n", user_num);
      doCallback(callback_msg);
      ris=0;
      break;
    }
  }
  return (&ris);
}






